package de.mlessmann.certassist.openssl;

import java.util.List;
import java.util.Objects;
import java.util.stream.Stream;
import lombok.Builder;
import lombok.Getter;

@Getter
@Builder
public class CertificateRequestExtension {

    private List<String> alternativeNames;

    public static class CertificateRequestExtensionBuilder {

        public CertificateRequestExtensionBuilder alternativeNames(String... altNames) {
            Objects.requireNonNull(altNames, "Alternative names must not be null (but can be empty)");
            this.alternativeNames =
            Stream
                .of(altNames)
                .filter(Objects::nonNull)
                .map(String::trim)
                .map(name -> name.replaceAll("^DNS:", ""))
                .toList();
            return this;
        }
    }
}
